
import '../../../flutter_agnes.dart';

class Data<T extends IModel> {
  int paginaAtual;
  int totalPaginas;
  int tamanhoPagina;
  int totalItens;
  dynamic cargasUteis;

  Data({this.paginaAtual, this.totalPaginas, this.tamanhoPagina, this.totalItens, this.cargasUteis});

  factory Data.fromJson(Map<String, dynamic> json, ObjectCreator<T> creator) {
    GenericModel<T> generic = new GenericModel<T>(creator);
    if (json["listaRetorno"] != null) {
      return Data(
        paginaAtual: json["paginaAtual"],
        totalPaginas: json["totalPaginas"],
        tamanhoPagina: json["tamanhoPagina"],
        totalItens: json["totalItens"],
        cargasUteis: List<T>.from(json["listaRetorno"].map((map) => generic.getObject(map))),
      );
    }else{
      return Data(cargasUteis: generic.getObject(json));
    }
  }
}
